/****************************************************************************
Tokimeki Mascot 95	(tmmascot.cpp)
	Ariyuki Kato	Dec.1996 - Feb.1997
*****************************************************************************/

//M
//	e`
//

#include <windows.h>
#include <windowsx.h>

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

#define PM_ENLARGE 201
#define PM_QUIT    202
#define PM_REVERSE 203
#define PM_SPEAK   204

#define PM_RANDOM 210
#define PM_SHIORI 211
#define PM_MIO    212
#define PM_YUINA  213
#define PM_AYAKO  214
#define PM_SAKI   215
#define PM_YUKARI 216
#define PM_NOZOMI 217
#define PM_MIRA   218
#define PM_YUKO   219
#define PM_MEGUMI 220
#define PM_YUMI   221
#define PM_MIHARU 222
#define PM_REI    223

#define PM_FAST 231
#define PM_NORM 232
#define PM_SLOW 233

HINSTANCE hInst_;
HWND hwndMainWindow = NULL;
const char gszAppName[] = "Ƃ߂Mascot95";
const char gszTokimekiMascotWndClassName[] = "TokimekiMascotWndClass";

int Mascot;
int MascotPrev;
// 0:D    1:   2:   3:ʎq   4:   5:䂩  6:]
// 7:    8:[q   9:    10:D  11:  12:C

int MascotIndex;		// }XRbg̏ԁi0-3:ړ 4-:Uj
int MascotX, MascotY;	// }XRbg̍W
int MascotDir;			// }XRbǧi1: -1:Ej
int MascotZoom;			// }XRbg̑傫 (1{, 2{)
int MascotSpeed;		// }XRbg֑̏xi1:, 2:ʁC3:xj 
BOOL MascotSpeak;		// }XRbg̉tO (TRUE:ׂj
BOOL MascotTurn;		// }XRbg̏ԃtO (TRUE:Uj
BOOL MascotRandom;		// _ɕϐg邩ǂ

POINT ptMouseLDown;
POINT ptWinDown;
BOOL fLButtonDown;

HBITMAP hbmpData[80];		// rbg}bṽnh
HPALETTE hpal[80];			// pbg̃nh
int hbmpDx[80], hbmpDy[80];	// rbg}bṽTCY

HRGN hregion[80];		// ʏTCY̗֊s[W
HRGN hregionRev[80];	// ʏTCY̔][W
HRGN hregion2[80];		// gTCY̗֊s[W
HRGN hregionRev2[80];	// gTCY̔][W

//	00-05: D		06-12: 		13-19: 		20-25: ʎq
//	26-31: 		32-37: 䂩	38-43: ]		44-49: 
//	50-55: [q		56-61: 		62-67: D		68-72: 		73-79: C
int MascotArray[13][8] =
	{ { 0,  1,  2,  3,  4,  5, -1, -1},
	  { 6,  7,  8, 10, 11, 12, -1, -1},
	  {13, 14, 15, 17, 18, 19, -1, -1},
	  {20, 21, 22, 23, 24, 25, -1, -1},
	  {26, 27, 28, 29, 30, 31, -1, -1},
	  {32, 33, 34, 35, 36, 37, -1, -1},
	  {38, 39, 40, 41, 42, 43, -1, -1},
	  {44, 45, 46, 47, 48, 49, -1, -1},
	  {50, 51, 52, 53, 54, 55, -1, -1},
	  {56, 57, 58, 59, 60, 61, -1, -1},
	  {62, 63, 64, 65, 66, 67, -1, -1},
	  {68, 69, 70, 71, 72, -1, -1, -1},
	  {73, 74, 75, 76, 77, 78, 79, -1} };

// }XRbg\̔z
int MascotWalk[13][11] =
	{ { 0,  1,  2,  1,  3,  4,  5,  4,  3, -1, -1},
	  { 6,  7,  8,  7, 10, 11, 12, 11, 10, -1, -1},
	  {13, 14, 15, 14, 17, 18, 19, 18, 17, -1, -1},
	  {20, 21, 22, 21, 23, 24, 25, 24, 23, -1, -1},
	  {26, 27, 28, 27, 29, 30, 31, 30, 29, -1, -1},
	  {32, 33, 34, 33, 35, 36, 37, 36, 35, -1, -1},
	  {38, 39, 40, 39, 41, 42, 43, 42, 41, -1, -1},
	  {44, 45, 46, 45, 47, 48, 49, 48, 47, -1, -1},
	  {50, 51, 52, 51, 53, 54, 55, 54, 53, -1, -1},
	  {56, 57, 58, 57, 59, 60, 61, 60, 59, -1, -1},
	  {62, 63, 64, 63, 65, 66, 67, 66, 65, -1, -1},
	  {72, 71, 70, 71, 69, 68, 69, 68, 69, -1, -1},
	  {73, 74, 75, 74, 76, 77, 78, 79, 77, 76, -1} };

// }XRbg̈ړԊuij
int MascotStep[13] = {3, 3, 3, 3, 3, 2, 3, 3, 4, 3, 4, 4, 3};

// }XRbg̏֊Ԋui^C}pj
int MascotTimer[13] = {225, 250, 200, 200, 225, 275, 225, 225, 175, 250, 175, 175, 275};

// ĐWAVEt@C
char MascotWave[13][13] =
	{ "shiori.wav", "mio.wav",  "yuina.wav",  "ayako.wav", "saki.wav",   "yukari.wav", "nozomi.wav",
	  "mira.wav",   "yuko.wav", "megumi.wav", "yumi.wav",  "miharu.wav", "rei.wav" };

// rbg}bvC[W쐬p
BITMAPINFO *pbmi;
LOGPALETTE *lpal;
BYTE *aData;
int aIndex;
POINT *lppt;
int cpoint;

// D_OMAK.CVT̃Ro[gp (Thanks for Melody-Yoshi)
struct tbs{
	short x,y,dx,dy,sx,sy,pix,dm;
	long dadr,padr;
};
typedef struct tbs* tb;
tb tbp;
short tbcnt;
long tbl;
short xofs,yofs;
unsigned char *by;
unsigned short pal[16];
FILE *fp;

// ֐vg^Cv錾
void convert(HWND);

long getlong(void);
short getshort(void);
short readsli(void);
void makepicture(short,short);
void wrbmphd(short,short);
void wrbmppl(void);

void makepolygon(HWND,short,short,int,int);
void invertpolygon(short,short,int);
short getpixeldata(int,int,short,short);


//F-------------------------------------------------------------------------
//	WinMain -- Gg
//--------------------------------------------------------------------------
int PASCAL WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpszCmdLine,
				   int nCmdShow)
{
	void InitApplication(HINSTANCE);
	void InitInstance(HINSTANCE, HINSTANCE, LPSTR);
	void InitMainWindow(HINSTANCE, int);
	int MessageLoop(void);

	// ŏ̃CX^X
	if (hPrevInst == NULL)
		InitApplication(hInst);
	// CX^XƂ̏
	InitInstance(hInst, hPrevInst, lpszCmdLine);
	// CEBhE̐
	InitMainWindow(hInst, nCmdShow);
	// bZ[W
	return MessageLoop();
}


//F-------------------------------------------------------------------------
//	InitApplication -- ŏ̃CX^X
//
//	@ɓAvP[VĂȂꍇɌĂяoA
//	EBhENX̓o^sB
//
// 
//		hInst: CX^X
//--------------------------------------------------------------------------
void InitApplication(HINSTANCE hInst)
{
	LRESULT CALLBACK _export TokimekiMascot_WndProc(HWND, UINT, WPARAM, LPARAM);
	// EBhENX̓o^
	WNDCLASS wndclass;
	// ETCYύXꂽƂEBhEŜĕ`悷
	wndclass.style			= CS_DBLCLKS;
	// EBhEɑ΂đ삵ƂĂяo֐
	wndclass.lpfnWndProc	= TokimekiMascot_WndProc;
	wndclass.cbClsExtra		= 0;
	wndclass.cbWndExtra		= 0;
	wndclass.hInstance		= hInst;
	// ftHg̃ACREJ[\
	wndclass.hIcon			= LoadIcon(hInst, "TOKIMEKIICON");
	wndclass.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wndclass.hbrBackground	= NULL;
	wndclass.lpszMenuName	= NULL;
	wndclass.lpszClassName	= gszTokimekiMascotWndClassName;
	RegisterClass(&wndclass);
}


//F-------------------------------------------------------------------------
//	InitInstance -- eCX^XƂ̏
//
//	@eCX^XƂɍsB
//
// 
//		hInst: JgCX^X
//		hPrevInst: ɓAvĂ΁ÃCX^X
//		lpszCmdLine: R}hC
//--------------------------------------------------------------------------
void InitInstance(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpszCmdLine)
{
	(void)hPrevInst;
	(void)hInst;

	randomize();

	// R}hCŃLw肪Ȃ΃_
	Mascot = atoi(lpszCmdLine) - 1;
	if ((Mascot >= 0) && (Mascot <= 12)) {
		MascotRandom = FALSE;
	} else {
		Mascot = random(13);
		MascotRandom = TRUE;
	}
}


//F-------------------------------------------------------------------------
//	InitMainWindow -- CEBhE̐
//
// 
//		hInst: CX^X
//		nCmdShow: \̎d
//--------------------------------------------------------------------------
void InitMainWindow(HINSTANCE hInst, int nCmdShow)
{
	(void)nCmdShow;

	hwndMainWindow = CreateWindowEx(
		//gEBhEX^C
		(GetVersion() & 0xff == 3) ? 0 : WS_EX_TOOLWINDOW,
		//o^ꂽNX̃AhX
		gszTokimekiMascotWndClassName,
		//EBhEeLXg̃AhX
		gszAppName,
		//EBhEX^C
		WS_POPUP | WS_SYSMENU,
		//EBhE̐Ẅʒu
		0,
		//EBhE̐Ẅʒu
		0,
		//EBhE̕
		64,
		//EBhE̍
		64,
		//eEBhẼnh
		NULL,
		//j[̃nh܂͎qEBhEID
		NULL,
		//AvP[VCX^X̃nh
		hInst,
		//EBhE쐬f[^̃AhX
		NULL);
}


//F-------------------------------------------------------------------------
//	MessageLoop -- bZ[W
//
//
// Ԃl
//		AvP[V̏IR[h
//--------------------------------------------------------------------------
int MessageLoop(void)
{
	MSG msg;

	for (;;) {
		if (GetMessage(&msg, NULL, 0, 0) != 0) {
			//bZ[WΏ
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		} else
			break;
	}

	//Av̏I
	int i, fmascot;
	for (i = 0; i < 80; i++) {
		for(fmascot = 0; ; fmascot++)
			if ((MascotArray[Mascot][fmascot] == i) || (MascotArray[Mascot][fmascot] == -1)) break;
		if (MascotArray[Mascot][fmascot] != -1) {
			DeleteObject(hregion[i]);
			DeleteObject(hregionRev[i]);
			DeleteObject(hregion2[i]);
			DeleteObject(hregionRev2[i]);
			DeleteObject(hbmpData[i]);
			DeleteObject(hpal[i]);
		}
	}

	return msg.wParam;
}


//F-------------------------------------------------------------------------
//	TokimekiMascot_WndProc -- EBhEvV[W
//
// 
//		hwnd: EBhEnh
//		uMsg: bZ[W
//		wParam: p[^
//		lParam: p[^
//
// Ԃl
//		bZ[W̏
//--------------------------------------------------------------------------
LRESULT CALLBACK _export TokimekiMascot_WndProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	BOOL TokimekiMascot_OnCreate(HWND, CREATESTRUCT FAR*);
	void TokimekiMascot_OnPaint(HWND);
	void TokimekiMascot_OnPaletteChanged(HWND, HWND);
	BOOL TokimekiMascot_OnEraseBkgnd(HWND, HDC);
	void TokimekiMascot_OnDestroy(HWND);
	void TokimekiMascot_OnLButtonDown(HWND, BOOL, int, int, UINT);
	void TokimekiMascot_OnLButtonUp(HWND, int, int, UINT);
	void TokimekiMascot_OnRButtonDown(HWND, BOOL, int, int, UINT);
	void TokimekiMascot_OnMouseMove(HWND, int, int, UINT);
	void TokimekiMascot_OnTimer(HWND, UINT);
	void TokimekiMascot_Enlarge(HWND);
	void TokimekiMascot_Change(HWND);

	switch(uMsg) {
		HANDLE_MSG(hwnd, WM_CREATE, TokimekiMascot_OnCreate);
		HANDLE_MSG(hwnd, WM_PAINT, TokimekiMascot_OnPaint);
		HANDLE_MSG(hwnd, WM_PALETTECHANGED, TokimekiMascot_OnPaletteChanged);
		HANDLE_MSG(hwnd, WM_ERASEBKGND, TokimekiMascot_OnEraseBkgnd);
		HANDLE_MSG(hwnd, WM_DESTROY, TokimekiMascot_OnDestroy);
		HANDLE_MSG(hwnd, WM_LBUTTONDOWN, TokimekiMascot_OnLButtonDown);
		HANDLE_MSG(hwnd, WM_LBUTTONUP, TokimekiMascot_OnLButtonUp);
		HANDLE_MSG(hwnd, WM_RBUTTONDOWN, TokimekiMascot_OnRButtonDown);
		HANDLE_MSG(hwnd, WM_MOUSEMOVE, TokimekiMascot_OnMouseMove);
		HANDLE_MSG(hwnd, WM_TIMER, TokimekiMascot_OnTimer);

		case WM_COMMAND:			// |bvAbvj[
			switch(wParam) {
				case PM_ENLARGE:	// TCYύX
					TokimekiMascot_Enlarge(hwnd);
					return 0;
				case PM_QUIT:		// Ij[
					PostQuitMessage(0);
					return 0;
				case PM_REVERSE:	// ]
					MascotDir *= -1;
					return 0;
				case PM_SPEAK:		// ON/OFF
					if (MascotSpeak == TRUE) MascotSpeak = FALSE; else MascotSpeak = TRUE;
					return 0;
				case PM_RANDOM: 	// ϐgON/OFF
					if (MascotRandom == TRUE) MascotRandom = FALSE; else MascotRandom = TRUE;
					return 0;
			}
			// }XRbg̕ύX
			if ((wParam >= PM_SHIORI) && (wParam <= PM_REI) && (wParam - PM_SHIORI != Mascot)) {
				MascotPrev = Mascot;
				Mascot = wParam - PM_SHIORI;
				TokimekiMascot_Change(hwnd);
				return 0;
			}
			// x̕ύX
			if ((wParam >= PM_FAST) && (wParam <= PM_SLOW)) {
				MascotSpeed = wParam - PM_FAST + 1;
				return 0;
			}

	}
	//AvȂƂ̃ftHg
	return DefWindowProc(hwnd, uMsg, wParam, lParam);
}


//F-------------------------------------------------------------------------
//	TokimekiMascot_OnCreate -- EBhE쐬
//
//	@EBhE쐬ɌĂ΂BTokimekiMascot ̏ꍇ͂
//	t@CǂݍݏsĂB
//
// Ԃl
//		FALSE Ԃ CreateWindow() ɎsB
//
//--------------------------------------------------------------------------
BOOL TokimekiMascot_OnCreate(HWND hwnd, CREATESTRUCT FAR* lpCreateStruct)
{
	void TokimekiMascot_OnPaint(HWND);

	(void) lpCreateStruct;

	if (hwndMainWindow != NULL) return TRUE;

	// p[^̐ݒ
	MascotZoom = 1;
	MascotIndex = 0;
	MascotDir = -1;
	MascotSpeed = 2;

	convert(hwnd);
	// ʂ̉Eo
	MascotX = GetSystemMetrics(SM_CXSCREEN);
	MascotY = GetSystemMetrics(SM_CYSCREEN) - hbmpDy[MascotWalk[Mascot][0]];
	MascotSpeak = TRUE;
	MascotTurn = FALSE;
	fLButtonDown = FALSE;

	TokimekiMascot_OnPaint(hwnd);
	SetTimer(hwnd, 1, MascotTimer[Mascot] * MascotSpeed / 2, NULL);
	return TRUE;
}


//F-------------------------------------------------------------------------
//	TokimekiMascot_OnPaint -- `
//
//
// 
//		hwnd: EBhEnh
//--------------------------------------------------------------------------
void TokimekiMascot_OnPaint(HWND hwnd)
{
	PAINTSTRUCT ps;
	HRGN hrgn1;

	// O[W̔j
    DeleteObject(hrgn1);
	// _~[̒`[W̍쐬
	hrgn1 = CreateRectRgn(0, 0,
		hbmpDx[MascotWalk[Mascot][MascotIndex]] * MascotZoom,
		hbmpDy[MascotWalk[Mascot][MascotIndex]] * MascotZoom);
	// _~[̃[WɎ[WRs[
	if ((MascotDir == -1) && (MascotZoom == 1)) {
		CombineRgn(hrgn1, hregion[MascotWalk[Mascot][MascotIndex]], NULL, RGN_COPY);
	} else if ((MascotDir == 1) && (MascotZoom == 1)) {
		CombineRgn(hrgn1, hregionRev[MascotWalk[Mascot][MascotIndex]], NULL, RGN_COPY);
	} else if ((MascotDir == -1) && (MascotZoom == 2)) {
		CombineRgn(hrgn1, hregion2[MascotWalk[Mascot][MascotIndex]], NULL, RGN_COPY);
	} else if ((MascotDir == 1) && (MascotZoom == 2)) {
		CombineRgn(hrgn1, hregionRev2[MascotWalk[Mascot][MascotIndex]], NULL, RGN_COPY);
	}

	// EBhẼ[Wƈʒu̐ݒ
  	SetWindowRgn(hwnd, hrgn1, TRUE);
	SetWindowPos(hwnd, HWND_TOPMOST, MascotX, MascotY,
		hbmpDx[MascotWalk[Mascot][MascotIndex]] * MascotZoom,
		hbmpDy[MascotWalk[Mascot][MascotIndex]] * MascotZoom,
		SWP_SHOWWINDOW | SWP_NOACTIVATE | SWP_NOCOPYBITS);
	ShowWindow(hwnd, SW_SHOW);

	// `
	BeginPaint(hwnd, &ps);

	HDC hdc = GetDC(hwnd);

	HPALETTE hpalOld = SelectPalette(hdc, hpal[MascotWalk[Mascot][MascotIndex]], TRUE);
	RealizePalette(hdc);

	HDC hdcImage = CreateCompatibleDC(hdc);
	SelectObject(hdcImage, hbmpData[MascotWalk[Mascot][MascotIndex]]);

	RECT lprc;
	GetClientRect(hwnd, &lprc);
	SetStretchBltMode(hdc, COLORONCOLOR);

    if (MascotDir == -1)
		StretchBlt(hdc, 0, 0,
			hbmpDx[MascotWalk[Mascot][MascotIndex]] * MascotZoom,
			hbmpDy[MascotWalk[Mascot][MascotIndex]] * MascotZoom,
			hdcImage, 0, 0,
			hbmpDx[MascotWalk[Mascot][MascotIndex]],
			hbmpDy[MascotWalk[Mascot][MascotIndex]], SRCCOPY);
	else
		StretchBlt(hdc, 0, 0,
			hbmpDx[MascotWalk[Mascot][MascotIndex]] * MascotZoom,
			hbmpDy[MascotWalk[Mascot][MascotIndex]] * MascotZoom,
			hdcImage, hbmpDx[MascotWalk[Mascot][MascotIndex]]-1, 0,
			-hbmpDx[MascotWalk[Mascot][MascotIndex]],
			hbmpDy[MascotWalk[Mascot][MascotIndex]], SRCCOPY);

	SelectPalette(hdc, hpalOld, TRUE);
	DeleteDC(hdcImage);
	ReleaseDC(hwnd, hdc);
	EndPaint(hwnd, &ps);

}


//F-------------------------------------------------------------------------
//	Tokimemo_OnPaletteChanged -- pbg̎̉
//
// 
//		hwnd: EBhEnh
//      hwndPaletteChanged: pbg̉EChẼnh
//--------------------------------------------------------------------------
void TokimekiMascot_OnPaletteChanged(HWND hwnd, HWND hwndPaletteChange)
{
	if (hwnd != hwndPaletteChange) {
		HDC hdc = GetDC(hwnd);
		HPALETTE hpalOld = SelectPalette(hdc, hpal[MascotWalk[Mascot][MascotIndex]], TRUE);
		int i = RealizePalette(hdc);
		SelectPalette(hdc, hpalOld, TRUE);
		ReleaseDC(hwnd, hdc);

		// pbg GgύXꂽꍇ́AEBhEĕ`悷
		if (i > 0) TokimekiMascot_OnPaint(hwnd);
	}
}


//F-------------------------------------------------------------------------
//	TokimekiMascot_OnLButtonDown/UP, MouseMove
//
//	NbNFނ
//	hbOFړ
//
//--------------------------------------------------------------------------
void TokimekiMascot_OnLButtonDown(HWND hwnd, BOOL fDoubleClick, int x, int y, UINT keyFlags)
{
	RECT rc;
	(void) fDoubleClick;
    (void) keyFlags;

	// pbg
	HDC hdc = GetDC(hwnd);
	HPALETTE hpalOld = SelectPalette(hdc, hpal[MascotWalk[Mascot][MascotIndex]], FALSE);
	RealizePalette(hdc);
	SelectPalette(hdc, hpalOld, TRUE);
	ReleaseDC(hwnd, hdc);

	// ݂̃}EX|C^̍Wۑ
    ptMouseLDown.x = x;
    ptMouseLDown.y = y;
	ClientToScreen(hwnd, &ptMouseLDown);

	// ݂̃EBhE̍Wۑ
	GetWindowRect(hwnd, &rc);
    ptWinDown.x = rc.left;
    ptWinDown.y = rc.top;

	// NbNC^C}[U~
	if (MascotTurn == TRUE) {
	   	KillTimer(hwnd, 2);
	} else {	
	   	KillTimer(hwnd, 1);
    }
	fLButtonDown = TRUE;
    SetCapture(hwnd);
}

//F NbNIFނ
void TokimekiMascot_OnLButtonUp(HWND hwnd, int x, int y, UINT keyFlags)
{
	POINT ptMouseNow;
    (void) keyFlags;

    ptMouseNow.x = x;
    ptMouseNow.y = y;
	ClientToScreen(hwnd, &ptMouseNow);

	// }EX|C^̈ʒuςĂȂ}XRbgɐU
    if ((ptMouseNow.x == ptMouseLDown.x) && (ptMouseNow.y == ptMouseLDown.y) && (MascotTurn == FALSE)) {
        SetTimer(hwnd, 2, MascotTimer[Mascot] * MascotSpeed / 2, NULL);
		MascotTurn = TRUE;
		if (MascotSpeak == TRUE) sndPlaySound(MascotWave[Mascot], SND_ASYNC | SND_NODEFAULT | SND_NOSTOP);
    } else if (MascotTurn == TRUE) {
		SetTimer(hwnd, 2, MascotTimer[Mascot] * MascotSpeed / 2, NULL);
	} else {
		SetTimer(hwnd, 1, MascotTimer[Mascot] * MascotSpeed / 2, NULL);
	}

    ReleaseCapture();
	fLButtonDown = FALSE;
}

//F hbOFړ
void TokimekiMascot_OnMouseMove(HWND hwnd, int x, int y, UINT keyFlags)
{
	POINT ptMouseNow;
	(void) x;
	(void) y;
    (void) keyFlags;

	if (fLButtonDown == TRUE) {
		GetCursorPos(&ptMouseNow);
        MascotX = ptWinDown.x + ptMouseNow.x - ptMouseLDown.x;
        MascotY = ptWinDown.y + ptMouseNow.y - ptMouseLDown.y;
		SetWindowPos(hwnd, HWND_TOPMOST, MascotX, MascotY,
			hbmpDx[MascotWalk[Mascot][MascotIndex]] * MascotZoom,
			hbmpDy[MascotWalk[Mascot][MascotIndex]] * MascotZoom, SWP_SHOWWINDOW | SWP_NOACTIVATE);
	}
}


//F-------------------------------------------------------------------------
//	TokimekiMascot_OnRButtonDown
//
//	NbNF|bvAbvC]Cg
//
//--------------------------------------------------------------------------
void TokimekiMascot_OnRButtonDown(HWND hwnd, BOOL fDoubleClick, int x, int y, UINT keyFlags)
{
	void TokimekiMascot_Enlarge(HWND);

    (void) x;
    (void) y;
	(void) fDoubleClick;

	if ((keyFlags & MK_SHIFT) != 0) {			// {VtgL[Ŋg
		TokimekiMascot_Enlarge(hwnd);
	} else if((keyFlags & MK_CONTROL) != 0) {	// {Rg[L[Ŕ]
	    MascotDir *= -1;
	} else {									// ̑Ń|bvAbvj[
		// |bvAbvj[̃[h
		HMENU _hMeguMenu = LoadMenu((HINSTANCE)GetWindowLong(hwnd, GWL_HINSTANCE), "TOKIMEKIMENU");
		HMENU hMeguMenu = GetSubMenu(_hMeguMenu, 0);
		RemoveMenu(_hMeguMenu, 0, MF_BYPOSITION);
		DestroyMenu(_hMeguMenu);

		// IvṼ`FbN
		if (MascotZoom == 2) CheckMenuItem(hMeguMenu, PM_ENLARGE, MF_BYCOMMAND | MF_CHECKED);
		if (MascotDir == 1) CheckMenuItem(hMeguMenu, PM_REVERSE, MF_BYCOMMAND | MF_CHECKED);
		if (MascotSpeak == TRUE) CheckMenuItem(hMeguMenu, PM_SPEAK, MF_BYCOMMAND | MF_CHECKED);
		if (MascotRandom == TRUE) CheckMenuItem(hMeguMenu, PM_RANDOM, MF_BYCOMMAND | MF_CHECKED);
		CheckMenuItem(hMeguMenu, PM_SHIORI + Mascot, MF_BYCOMMAND | MF_CHECKED);
		switch (MascotSpeed) {
			case 1:
				CheckMenuItem(hMeguMenu, PM_FAST, MF_BYCOMMAND | MF_CHECKED);
				break;
			case 2:
				CheckMenuItem(hMeguMenu, PM_NORM, MF_BYCOMMAND | MF_CHECKED);
				break;
			case 3:
				CheckMenuItem(hMeguMenu, PM_SLOW, MF_BYCOMMAND | MF_CHECKED);
				break;
		}

		// |bvAbvj[̕\
		POINT pt;
		GetCursorPos(&pt);
		TrackPopupMenu(hMeguMenu, TPM_LEFTALIGN, pt.x, pt.y, 0, hwnd, NULL);
		DestroyMenu(hMeguMenu);
	}
}


//F-------------------------------------------------------------------------
//	TokimekiMascot_Enlarge
//
//	g
//
//--------------------------------------------------------------------------
void TokimekiMascot_Enlarge(HWND hwnd)
{
	ShowWindow(hwnd, SW_HIDE);

	if (MascotZoom == 1) {
		MascotZoom = 2;
		MascotY = MascotY - hbmpDy[MascotWalk[Mascot][0]];
	} else {
		MascotZoom = 1;
		MascotY = MascotY + hbmpDy[MascotWalk[Mascot][0]];
		// kĉʂ͂ݏoƂ̏
		if (MascotY > GetSystemMetrics(SM_CYSCREEN) - hbmpDy[MascotWalk[Mascot][0]])
			MascotY = GetSystemMetrics(SM_CYSCREEN) - hbmpDy[MascotWalk[Mascot][0]];
	}

	TokimekiMascot_OnPaint(hwnd);
}


//F-------------------------------------------------------------------------
//	TokimekiMascot_Change
//
//	LύX
//
//--------------------------------------------------------------------------
void TokimekiMascot_Change(HWND hwnd)
{
	ShowWindow(hwnd, SW_HIDE);

	int i, fmascot;
	for (i = 0; i < 80; i++) {
		for(fmascot = 0; ; fmascot++)
		if ((MascotArray[MascotPrev][fmascot] == i) || (MascotArray[MascotPrev][fmascot] == -1)) break;
		if (MascotArray[MascotPrev][fmascot] != -1) {
			DeleteObject(hregion[i]);
			DeleteObject(hregionRev[i]);
			DeleteObject(hregion2[i]);
			DeleteObject(hregionRev2[i]);
			DeleteObject(hbmpData[i]);
			DeleteObject(hpal[i]);
		}
	}

	convert(hwnd);
	MascotIndex = 0;
	MascotTurn = FALSE;
	fLButtonDown = FALSE;
	KillTimer(hwnd, 2);
	SetTimer(hwnd, 1, MascotTimer[Mascot] * MascotSpeed / 2, NULL);

	TokimekiMascot_OnPaint(hwnd);
}


//F-------------------------------------------------------------------------
//	TokimekiMascot_OnEraseBkgnd
//
//	wi
//		ȂƂɂ肿h~
//--------------------------------------------------------------------------
BOOL TokimekiMascot_OnEraseBkgnd(HWND hwnd, HDC hdc)
{
	(void)hwnd;
	(void)hdc;
	return TRUE;
}


//F-------------------------------------------------------------------------
//	TokimekiMascot_OnTimer -- ^C}[
//
// 
//		hwnd: EBhEnh
//      wTimerID: ^C}ʎq
//--------------------------------------------------------------------------
void TokimekiMascot_OnTimer(HWND hwnd, UINT wTimerID)
{
	void TokimekiMascot_Change(HWND);

	switch (wTimerID) {
		case 1:				// ړ
			MascotIndex++;
    		if (MascotIndex > 3) MascotIndex = 0;
			MascotX += MascotStep[Mascot] * MascotDir * MascotZoom;
			// ʂ͂ݏoꍇ̏
    		if (MascotX < -hbmpDx[MascotWalk[Mascot][0]] * MascotZoom) {
				MascotX = GetSystemMetrics(SM_CXSCREEN);
					if (MascotRandom == TRUE) {
					MascotPrev = Mascot;
					Mascot = random(13);
					TokimekiMascot_Change(hwnd);
				}
			}
    		if (MascotX > GetSystemMetrics(SM_CXSCREEN)) {
				MascotX = -hbmpDx[MascotWalk[Mascot][0]] * MascotZoom;
				if (MascotRandom == TRUE) {
					MascotPrev = Mascot;
					Mascot = random(13);
					TokimekiMascot_Change(hwnd);
				}
			}
			if ((MascotIndex == 1) || (MascotIndex == 3))
				SetTimer(hwnd, 1, MascotTimer[Mascot] * MascotSpeed / 2, NULL);
			else
				SetTimer(hwnd, 1, MascotTimer[Mascot] * MascotSpeed * 5 / 8, NULL);
    		break;
        case 2:				// U
			if (MascotIndex < 4) MascotIndex = 4; else MascotIndex++;
            // UȈꍇ
			if (MascotWalk[Mascot][MascotIndex] == -1) {
            	MascotIndex = 0;
				KillTimer(hwnd, 2);
				MascotTurn = FALSE;
				SetTimer(hwnd, 1, MascotTimer[Mascot] * MascotSpeed / 2, NULL);
			} else
				SetTimer(hwnd, 2, MascotTimer[Mascot] * MascotSpeed / 2, NULL);
			break;
	}

	TokimekiMascot_OnPaint(hwnd);
}


//F-------------------------------------------------------------------------
//	TokimekiMascot_OnDestroy -- AvP[VI
//
// 
//		hwnd: EBhEnh
//--------------------------------------------------------------------------
void TokimekiMascot_OnDestroy(HWND hwnd)
{
	(void)hwnd;

	PostQuitMessage(0);
}


//F-------------------------------------------------------------------------
//	convet -- D_OMAK.CVT̃Ro[g
//
//		Thanks for Melody-Yoshi
//--------------------------------------------------------------------------
void convert(HWND hwnd)
{
	short i,j,dx,dy;
	unsigned char fz[32];
	tbl=0x7498L;
	if((fp=fopen("d_omak.cvt","rb"))==NULL){
		MessageBox(NULL, "D_OMAK.CVTJ܂", "Ƃ߂G[", MB_OK | MB_ICONSTOP);
		exit(1);
	}
	by=(unsigned char *)LocalAlloc(LPTR, 0x2000);
	for(j=0;;){
		fseek(fp,tbl,0);i=getshort();
		if(i<=0)break;
		fseek(fp,tbl+12L,0);
		tbl+=0x4C;
		while(1){
			fseek(fp,(long)tbl,0);tbcnt=getshort();
			if(tbcnt<=0)break;
			i=(short)fread(fz,1,10,fp);
			if(fz[9]==0x80 && fz[5]==0x80){
				tbl+=tbcnt*8L+8;continue;
			}
			if(fz[5]==0x80 && fz[9]==0)break;
			tbl+=12L;
			tbp=(tb)LocalAlloc(LPTR, (tbcnt)*sizeof(struct tbs));
			for(i=dx=dy=xofs=yofs=0;i<tbcnt;i++,tbl+=24L){
				tbp[i].x=getshort();
				tbp[i].y=getshort();
				if(tbp[i].x<dx)dx=tbp[i].x;
				if(tbp[i].y<dy)dy=tbp[i].y;
				tbp[i].dadr=getlong();
				tbp[i].padr=getlong();
				tbp[i].pix=getshort();
				tbp[i].sx=getshort();
				tbp[i].sy=getshort();
				tbp[i].dm=getshort();
				tbp[i].dx=getshort();
				tbp[i].dy=getshort();
			}
			xofs=(short)-dx;yofs=(short)-dy;
			for(i=dx=dy=0;i<tbcnt;i++){
				tbp[i].x+=xofs;tbp[i].y+=yofs;
				if(dx<tbp[i].x+(short)tbp[i].dx)dx=(short)(tbp[i].x+tbp[i].dx);
				if(dy<tbp[i].y+(short)tbp[i].dy)dy=(short)(tbp[i].y+tbp[i].dy);
			}
			for(i=0;i<tbcnt;i++){
				tbp[i].dadr&=0xFFFFL;tbp[i].padr&=0xFFFFL;
			}

			int fmascot;
			for(fmascot = 0; ; fmascot++)
				if ((MascotArray[Mascot][fmascot] == j) || (MascotArray[Mascot][fmascot] == -1)) break;

			if (MascotArray[Mascot][fmascot] != -1) {
				pbmi = (BITMAPINFO*)LocalAlloc(LPTR, sizeof(BITMAPINFOHEADER) + sizeof(DWORD) * 16);
				lpal = (LOGPALETTE*)LocalAlloc(LPTR, sizeof(LOGPALETTE) + sizeof(PALETTEENTRY) * 16);
				aData = (BYTE*)LocalAlloc(LPTR, sizeof(BYTE) * dx * dy);
				aIndex = 0;

				wrbmphd(dx,dy);
				fseek(fp,tbp[0].padr+(long)tbp[0].pix*32L+12L,0);
				fread((unsigned char *)pal,1,32,fp);
				wrbmppl();
				makepicture(dx,dy);

				// pbgDDB̍쐬
				HDC hdc = GetDC(hwnd);
				hpal[j] = CreatePalette(lpal);
				HPALETTE hpalOld = SelectPalette(hdc, hpal[j], FALSE);
				RealizePalette(hdc);
				hbmpData[j] = CreateDIBitmap(hdc,(BITMAPINFOHEADER*)pbmi, CBM_INIT, aData, pbmi, DIB_PAL_COLORS);
				hbmpDx[j] = dx; hbmpDy[j] = dy;
				SelectPalette(hdc, hpalOld, FALSE);
				ReleaseDC(NULL, hdc);

				// ֊s[W̍쐬
				lppt = (POINT*)LocalAlloc(LPTR, sizeof(POINT) * 1024);
				makepolygon(hwnd, dx, dy, j, 1);
				hregion[j] = CreatePolygonRgn(lppt, cpoint, WINDING);
				invertpolygon(dx,dy,1);
				hregionRev[j] = CreatePolygonRgn(lppt, cpoint, WINDING);
				makepolygon(hwnd, dx, dy, j, 2);
				hregion2[j] = CreatePolygonRgn(lppt, cpoint, WINDING);
				invertpolygon(dx,dy,2);
				hregionRev2[j] = CreatePolygonRgn(lppt, cpoint, WINDING);

				LocalFree((HLOCAL)lppt);
				LocalFree((HLOCAL)pbmi);
				LocalFree((HLOCAL)lpal);
				LocalFree((HLOCAL)aData);
			}
			LocalFree((HLOCAL)tbp);
			j++;
		}
	}
	LocalFree((HLOCAL)by); fclose(fp);
	return;
}

//F convert̉ -- MAKE PICTURE
void makepicture(short dx,short dy)
{
	short i,j,n,y,xx;
	long yy;
	for(n=0;n<tbcnt;n++){
		yy=dy-1-tbp[n].y;xx=(short)(tbp[n].sy*64+tbp[n].sx/2);
		fseek(fp,tbp[n].dadr,0);fgetc(fp);
		i=(short)fgetc(fp);fseek(fp,tbp[n].dadr+12L,0);
		if(i==1)readsli();
		else{
			MessageBox(NULL, "D_OMAK.CVTJ܂", "Ƃ߂G[", MB_OK | MB_ICONSTOP);
			exit(1);
		}
		for(y=0;y<tbp[n].dy;y++){
			aIndex = tbp[n].x/2+(yy-(long)y)*(long)dx/2;
			for(j=0;j<tbp[n].dx/2;j++){
				aData[aIndex++] = (short)(((by[64*y+xx+j]&0xf0)>>4)|((by[64*y+xx+j]&0x0f)<<4));
			}
		}
	}
}

//F convert̉ -- PRESS DATA
short readsli(void)
{
	short i,j,k,m,cnt,adr;
	for(cnt=0;;){
		i=(short)fgetc(fp);
		for(j=0;j<8;j++){
			k=(short)fgetc(fp);
			if(i&1){
				if((k&0x80)==0){
					m=(short)((k>>2)+3);adr=(short)(cnt-(fgetc(fp)+(k&3)*256));
					for(k=0;k<m;k++,cnt++,adr++)by[cnt]=by[adr];
				}
				else{
					if(k==0xFF)return(0);
					if((k&0x40)==0){
						m=(short)(((k&0x30)>>4)+2);adr=(short)(cnt-(k&0x0f)-1);
						for(k=0;k<m;k++,cnt++,adr++)by[cnt]=by[adr];
					}
					else{
						m=(short)(((k&0x3f))+8);
						for(k=0;k<m;k++,cnt++)by[cnt]=(short)fgetc(fp);
					}
				}
			}
			else by[cnt++]=k;
			i>>=1;
		}
	}
}

//F convert̉ -- WRITE BMP HEADER
void wrbmphd(short dx,short dy)
{
	short i;
	pbmi->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	pbmi->bmiHeader.biWidth = dx;
	pbmi->bmiHeader.biHeight = dy;
	pbmi->bmiHeader.biPlanes = 1;
	pbmi->bmiHeader.biBitCount = 4;
	pbmi->bmiHeader.biCompression = BI_RGB;
	pbmi->bmiHeader.biClrUsed = 0;
	pbmi->bmiHeader.biClrImportant = 0;
	for (i = 0; i < 16; i++) ((WORD*)(pbmi->bmiColors))[i] = i;
}

//F convert̉ -- WRITE PALETTE DATA
void wrbmppl(void)
{
	short i;
	lpal->palNumEntries = 16;
	lpal->palVersion = 0x300;
	for(i=0;i<16;i++){
		lpal->palPalEntry[i].peBlue = (short)((pal[i]&0x7c00)>>7);		/* BLUE */
		lpal->palPalEntry[i].peGreen = (short)((pal[i]&0x3e0)>>2);		/* GREEN */
		lpal->palPalEntry[i].peRed = (short)((pal[i]&0x1f)<<3);		/* RED */
		lpal->palPalEntry[i].peFlags = NULL;
	}
}

//F convert̉ -- READ LONG VALUE
long getlong(void)
{
	long i;
	i=(long)fgetc(fp);
	i+=(long)fgetc(fp)*256L;
	i+=(long)fgetc(fp)*65536L;
	fgetc(fp);
	return(i);
}

//F convert̉ -- READ SHORT VALUE
short getshort(void)
{
	short i;
	i=(short)fgetc(fp);i+=(short)(fgetc(fp)*256);
	return(i);
}


//F-------------------------------------------------------------------------
//	makepolygon -- ֊s[W̒o
//
//		Thanks for ݂
//--------------------------------------------------------------------------
void makepolygon(HWND hwnd, short dx, short dy, int j, int mag)
{
	int x, y;
	int cx, cy;
	int px, py;
	int sx, sy;
	int cnt;
	int dir, curDir;
	short back;

	(void)hwnd;

	cpoint = 1;
	lppt[0].x = lppt[0].y = -1;
	back = getpixeldata(0, 0, dx, dy);

	for (y = 0; y < dy; y++) {
		for (x = 0; x < dx; x++) {
			if ((getpixeldata(x, y, dx, dy) != back) && (lppt[0].x == -1)) {
				lppt[0].x = x * mag - 1; if (lppt[0].x < 0) lppt[0].x = 0; px = sx = x;
				lppt[0].y = y * mag - 1; if (lppt[0].y < 0) lppt[0].y = 0; py = sy = y;
			}
		}
	}

	dir = 2;
	for (;;) {
		curDir = (dir + 5) % 8;
		for (cnt = 0; cnt < 8; cnt++) {
			switch (curDir) {
				case 0: cx =  0; cy = -1; break;
				case 1: cx =  1; cy = -1; break;
				case 2: cx =  1; cy =  0; break;
				case 3: cx =  1; cy =  1; break;
				case 4: cx =  0; cy =  1; break;
				case 5: cx = -1; cy =  1; break;
				case 6: cx = -1; cy =  0; break;
				case 7: cx = -1; cy = -1; break;
			}
			if ((getpixeldata(px + cx, py + cy, dx, dy) != back)
				&& (px + cx >= 0) && (px + cx < dx)
				&& (py + cy >= 0) && (py + cy < dy)) {
				px = px + cx;
				py = py + cy;
				switch (curDir) {
					case 0:
						if (mag == 2) lppt[cpoint].x = px * mag - 1; else lppt[cpoint].x = px * mag;
						lppt[cpoint].y = py * mag;
						break;
					case 1:
						if (mag == 2) lppt[cpoint].x = px * mag - 1; else lppt[cpoint].x = px * mag;
						lppt[cpoint].y = py * mag - 1;
						break;
					case 2:
						lppt[cpoint].x = px * mag;
						lppt[cpoint].y = py * mag - 1;
						break;
					case 3:
						lppt[cpoint].x = px * mag + 1;
						lppt[cpoint].y = py * mag - 1;
						break;
					case 4:
						lppt[cpoint].x = px * mag + 1;
						lppt[cpoint].y = py * mag;
						break;
					case 5:
						lppt[cpoint].x = px * mag + 1;
						lppt[cpoint].y = py * mag + 1;
						break;
					case 6:
						lppt[cpoint].x = px * mag;
						lppt[cpoint].y = py * mag + 1;
						break;
					case 7:
						if (mag == 2) lppt[cpoint].x = px * mag - 1; else lppt[cpoint].x = px * mag;
						lppt[cpoint].y = py * mag + 1;
						break;
				}

				if (lppt[cpoint].x < 0) lppt[cpoint].x = 0;
				if (lppt[cpoint].y < 0) lppt[cpoint].y = 0;
				if (lppt[cpoint].x > dx * mag) lppt[cpoint].x = dx * mag;
				if (lppt[cpoint].y > dy * mag) lppt[cpoint].y = dy * mag;

				dir = curDir;
				cpoint++;
				cnt = 8;
			}
			curDir = (curDir + 1) % 8;
		}
		if ((sx == px) && (sy == py)) break;
	}

	lppt[cpoint].x = lppt[0].x;
	lppt[cpoint].y = lppt[0].y;
	cpoint++;

	if (mag == 2) {
		for (j = 0; j < cpoint; j++) {
			lppt[j].x = lppt[j].x + 1;
			lppt[j].y = lppt[j].y + 1;
		}
	}
}

//F makepolygon̉ --INVERT POLYGON
void invertpolygon(short x, short y, int mag)
{
	(void) y;

	for(int i = 0; i < cpoint; i++) lppt[i].x = x * mag - lppt[i].x;
}

//F makepolygon̉ --GET PIXEL DATA
short getpixeldata(int x, int y, short dx, short dy)
{
	int perline = ((dx + 3) / 4) * 2;
	int offset = perline * (dy - y - 1) + x / 2;
	int value;

	switch (x % 2) {
		case 1:
			value = aData[offset] & 0xf;
			break;
		case 0:
			value = (aData[offset] & 0xf0) >> 4;
			break;
	}

	return (short)value;
}
